
#include "LCD_2x16_74HC595.h"
#include "built_in.h"

#define SHIFT_CLOCK    RB0_bit
#define SHIFT_DATA     RB1_bit
#define SHIFT_LATCH    RB2_bit


char LCD_Port=0;

void Write_74HC595(unsigned char _shiftdata)
{
unsigned int i;
unsigned char valor;
valor = _shiftdata;
i=8;
while (i>0)
{
if ((valor&0x80)==0)
{
SHIFT_DATA = 0;
}
else
{
SHIFT_DATA = 1;
}
valor = valor<<1;
SHIFT_CLOCK = 1;
Delay_us(1);
SHIFT_CLOCK = 0;
i--;
}
SHIFT_LATCH = 1;
Delay_us(5);
SHIFT_LATCH = 0;
Delay_us(5);
}

void LCD_Command (char _cmd)	/* LCD16x2 command funtion */
{

LCD_Port =(LCD_Port & 0x0F) | (_cmd & 0xF0);/* Send upper nibble */
Write_74HC595(LCD_Port);

LCD_Port =(LCD_Port & 0xF3); // rs=0 , rw=0
Write_74HC595(LCD_Port);

LCD_Port =(LCD_Port | 0x02);	//en=1;
Write_74HC595(LCD_Port);
delay_ms(1);
LCD_Port =(LCD_Port & 0xFC);	//en=0;
Write_74HC595(LCD_Port);
delay_ms(2);

LCD_Port = (LCD_Port & 0x0F) | (_cmd << 4);/* Send lower nibble */
Write_74HC595(LCD_Port);
/* Enable pulse */
LCD_Port =(LCD_Port | 0x02);	//en=1;
Write_74HC595(LCD_Port);
delay_ms(1);
LCD_Port =(LCD_Port & 0xFC);	//en=0;
Write_74HC595(LCD_Port);
delay_ms(5);
}

 void LCD_Char (char char_data)  /* LCD data write function */
{
 
    /*Data reg.*/
  //*Write operation*/
 
   LCD_Port =(LCD_Port & 0x0F);
   Write_74HC595(LCD_Port);
   
   LCD_Port =(LCD_Port & 0x0F) | (char_data & 0xF0);/* Send upper nibble */
   Write_74HC595(LCD_Port);
   LCD_Port =(LCD_Port | 0x0A); // rs=1  en=1
   Write_74HC595(LCD_Port);
   LCD_Port =(LCD_Port & 0xFB); // rw=0
   Write_74HC595(LCD_Port);
   LCD_Port =(LCD_Port | 0x02);	//en=1;
   Write_74HC595(LCD_Port);
   delay_ms(1);
   LCD_Port =(LCD_Port & 0xFC);	//en=0;
   Write_74HC595(LCD_Port);
   delay_ms(2);
   LCD_Port = (LCD_Port & 0x0F) | (char_data << 4);/* Send lower nibble */
   Write_74HC595(LCD_Port);

/* Enable pulse */
 LCD_Port =(LCD_Port | 0x02);	//en=1;
 Write_74HC595(LCD_Port);
 delay_ms(1);
 LCD_Port =(LCD_Port & 0xFC);	//en=0;
 Write_74HC595(LCD_Port);
 delay_ms(5);
}

void LCD_Char_xy (char row, char pos, char ch)	/* Send string to LCD function */
{
      if((pos-1) == 0) LCD_command(0x80 | (row-1));

      else  LCD_command(0x80 | 0x40 | (row-1));

      LCD_Char (ch);  /* Call LCD data write */

}

void LCD_String_xy (char row, char pos, char *str)  /* Send string to LCD function */
{
 short int i;
 
   if((pos-1) == 0)   LCD_command(0x80 | (row-1));

    else  LCD_command(0x80 | 0x40 | (row-1));

  for(i=0;str[i]!=0;i++)  /* Send each char of string till the NULL */
	{
		LCD_Char (str[i]);  /* Call LCD data write */
	}
}

void LCD_Init (void)		/* LCD Initialize function */
{
	delay_ms(15);		/* LCD Power ON Initialization time >15ms */
	LCD_Command(mode_4bit);	/* 4bit mode */
	LCD_Command(Init);	/* Initialization of 16X2 LCD in 4bit mode */
	LCD_Command (display_on); /* Display ON Cursor OFF */
	LCD_Command (cursor_direction_inc);/* Auto Increment cursor */
	LCD_Command (clear_display);	/* clear display */
	LCD_Command (home_at_cursor);	/* cursor at home position */
}
